;
;                       EZCMP Muliple Pass .asm file
;                    EZCMP Zshell CoMPression library
;                        (c) 1997 by Chris Busch
;               (ported to the TI-82 by Wouter Demuynck)
;                  Read EZCMP.TXT for more information
;
;         (This file includes the single pass decompressor.)
;
; The following variables need to be declared some where.
;       EZdest start anywhere (like TEXT_MEM for example)
;       EZdest     = TEXT_MEM        ; word
;       EZdestdone = EZdest     + 2  ; word
;       EZlookup   = EZdestdone + 2  ; word
;
; EZCMPDecodeMPass
;  input : hl -> EZCMPdataPASSES     ; Number of passes
;  note :
;   - Only works with data <= 768 bytes
;   - If you use this with data >768 bytes, you can update this routine
;     to use alocated space in your program
;   - On completion, both GRAPH_MEM and APD_BUF will contain the output 
;     image
;   - If an interrupt is running in the APD_BUF, your calc _WILL_ crash !
;


; include the single pass decoder
#include "ezcmpsp.asm"

EZCMPDecodeMPass:
   ld   a,(hl) ; load first byte which is count of passes (1 or greater)
   inc  hl     ; let hl point to start of compressed data (only for 1st pass)
   ld   b,a    ; b contains the count of passes 
EZCMPloopmp:
   push bc               ; save bc (destroyed in EZCMPDecodeOPass)
   ld   de,APD_BUF                   
   call EZCMPDecodeOPass ; decompress to APD_BUF
   
   ld   hl,APD_BUF        
   ld   de,GRAPH_MEM
   ld   bc,768                      
   ldir                  ; copy APD_BUF to GRAPH_MEM           
   
   ld   hl,GRAPH_MEM     ; from 2nd pass on, compressed data is in GRAPH_MEM
   pop  bc               ; restore bc
   djnz EZCMPloopmp      ; loop
   ret                   ; return




