;
;                       EZCMP Single Pass .asm file
;                    EZCMP Zshell CoMPression library
;                        (c) 1997 by Chris Busch
; 'ported' to TI-82 by Wouter Demuynck (There was actually nothing that
; had to be changed, only in the example routines and the multiple pass)
;
;
;      (This file is included by the multiple pass decompressor.)
;
;
; The following variables need to be declared some where.
; EZdest start anywhere (like TEXT_MEM for example)
;       EZdest     = TEXT_MEM        ; word
;       EZdestdone = EZdest     + 2  ; word
;       EZlookup   = EZdestdone + 2  ; word
;
; EZCMPDecodeOPass
; Input : hl -> EZCMPdata (compressed data)
;         de -> Destiny (uncompressed data)
; Destroyed registers : all
; Notes : 
;  - HL points to the data after the one byte containing the number of passes
; 
; (To compress using only one pass use -s option.)
;

EZshift    = $0F                    ; Nibble shift indicator

EZCMPDecodeOPass:  ;;decode for one pass ezcmp aligned compression technique
   ld (EZdest),de
   ld a,(hl) \   ld (EZdestdone),a     \ inc hl   ;;storing count
   ld a,(hl) \   ld (EZdestdone+1),a   \ inc hl   ;;
   ld (EZlookup),hl                 ;;storing lookup table
   ld bc,15
   add hl,bc
   ld b,h                           ;*; ld bc,hl
   ld c,l                           ;*;    hl points to start of source
   ld  hl,(EZdestdone)
   ld  de,(EZdest)
   add hl,de
   ld  (EZdestdone),hl              ;;will stop decode when reached destdone
EZdecodeloop:
   ld  hl,(EZdest)
   ld  de,(EZdestdone)              ;;{check for completion
   call CP_HL_DE                    ;;
   ret z                            ;;}
;;;;;;;;;;;;;;;;first nibble (msn)
   ld a,(bc)                        ;*;
   srl a \ srl a \ srl a \ srl a    ;;use upper nibble
   cp  EZshift
   jr  nz,EZnotshift
EZisshift: ;;next nibble is run
   ld h,b                           ;*;
   ld l,c                           ;*;
   ld  a,(hl)
   and 0Fh
   inc a
   ld  b,0 \ ld c,a \ inc hl \ ld  de,(EZdest)
   ldir
   ld (EZdest),de
   ld b,h                           ;*;
   ld c,l                           ;*;
   jr  EZdecodeloop
EZnotshift:
   ld  d,0
   ld  e,a
   ld  hl,(EZlookup)
   add hl,de
   ld  a,(hl)                       ;; hl -> into lookup table
   ld  hl,(EZdest) \ ld (hl),a \ inc hl \ ld (EZdest),hl
   ld de,(EZdestdone) ;;{check for completion
   call CP_HL_DE      ;; must be done since stream can contain 1 pack nibble
   ret z              ;;}
;;;;;second nibble  (lsn)
   ld a,(bc)                        ;*;
   and 0Fh
   cp  EZshift
   jr  nz,EZnot2shift
EZis2shift:
   inc bc                           ;*;
   ld a,(bc)                        ;*; fetched next byte
   inc bc                           ;*; source+=2
   ld  hl,(EZdest)
   ld  (hl),a                       ; store the next byte
   inc hl
   ld  (EZdest),hl                  ; store destination
   jr EZdecodeloop
EZnot2shift:
   ld  d,0
   ld  e,a
   ld  hl,(EZlookup)
   add hl,de
   ld  a,(hl)                       ; hl-> into lookup table
   ld  hl,(EZdest) \ ld (hl),a \ inc hl \ ld (EZdest),hl
   inc bc                           ;*; source += 1
   jr EZdecodeloop
;;;;;;;;;end ezcmp decode one pass


;;;;;;;;;;;;;;;;;;end of this file
